## dhewm3 0+git20150226+dfsg

=== neo/CMakeLists.txt ===
project(dhewm3)
cmake_minimum_required(VERSION 2.6)

# TODO

# osx: place game .dylib's in the bundle (next to the binary)
# osx: -weak_framework ?

# maybe add these as options:
# TARGET_MONO
# SETUP
# SDK				-D_D3SDK

# don't add these as options, but document them?
# IDNET_HOST		-DIDNET_HOST=\\"%s\\"' % IDNET_HOST
# DEBUG_MEMORY		-DID_DEBUG_MEMORY', '-DID_REDIRECT_NEWDELETE
# LIBC_MALLOC		-DUSE_LIBC_MALLOC=0
# ID_NOLANADDRESS	-DID_NOLANADDRESS

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/sys/cmake")
set(CMAKE_SKIP_RPATH ON CACHE BOOL "Skip RPATH" FORCE)

include(CheckCXXCompilerFlag)
include(CheckFunctionExists)
include(GNUInstallDirs OPTIONAL RESULT_VARIABLE GNUINSTALLDIRS)

option(CORE			"Build the core" ON)
option(BASE			"Build the base game code" ON)
option(D3XP			"Build the d3xp game code" ON)
option(DEDICATED	"Build the dedicated server" OFF)
option(ONATIVE		"Optimize for the host CPU" OFF)
option(SDL2			"Use SDL2 instead of SDL1.2" OFF)

if(NOT CMAKE_SYSTEM_PROCESSOR)
	message(FATAL_ERROR "No target CPU architecture set")
endif()

if(NOT CMAKE_SYSTEM_NAME)
	message(FATAL_ERROR "No target OS set")
endif()

# target cpu
set(cpu ${CMAKE_SYSTEM_PROCESSOR})
if(cpu STREQUAL "powerpc")
	set(cpu "ppc")
elseif(cpu MATCHES "i.86")
	set(cpu "x86")
endif()

if(MSVC AND CMAKE_CL_64)
	set(cpu "amd64")
endif()

# target os
if(APPLE)
	set(os "macosx")
else()
	string(TOLOWER "${CMAKE_SYSTEM_NAME}" os)
endif()

# build type
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

# precompiled libraries from the dhewm3-libs repo
if(DHEWM3LIBS)
	if(CMAKE_CROSSCOMPILING)
		set(CMAKE_FIND_ROOT_PATH ${DHEWM3LIBS})
	else()
		set(ENV{CMAKE_PREFIX_PATH} ${DHEWM3LIBS})
	endif()

	# these are too stupid, give them a hint
	set(ENV{OPENALDIR} ${DHEWM3LIBS})
	set(ENV{SDLDIR} ${DHEWM3LIBS})
	set(ENV{SDL2DIR} ${DHEWM3LIBS})
endif()

# libs
find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIRS})

find_package(JPEG REQUIRED)
include_directories(${JPEG_INCLUDE_DIR})

set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARY})
CHECK_FUNCTION_EXISTS("jpeg_mem_src" HAVE_JPEG_MEM_SRC)

find_package(OGG REQUIRED)
include_directories(${OGG_INCLUDE_DIR})

find_package(Vorbis REQUIRED)
include_directories(${VORBIS_INCLUDE_DIR})

find_package(VorbisFile REQUIRED)
include_directories(${VORBISFILE_INCLUDE_DIR})

find_package(OpenAL REQUIRED)
include_directories(${OPENAL_INCLUDE_DIR})

if (SDL2)
	# skip SDL2main
	if(APPLE OR WIN32)
		set(SDL2_BUILDING_LIBRARY TRUE)
	endif()
	find_package(SDL2 REQUIRED)
	include_directories(${SDL2_INCLUDE_DIR})
	set(SDLx_LIBRARY ${SDL2_LIBRARY})
else()
	# skip SDLmain
	if(APPLE OR WIN32)
		set(SDL_BUILDING_LIBRARY TRUE)
	endif()
	find_package(SDL REQUIRED)
	include_directories(${SDL_INCLUDE_DIR})
	set(SDLx_LIBRARY ${SDL_LIBRARY})
endif()

find_package(CURL QUIET)
if(CURL_FOUND)
	set(ID_ENABLE_CURL ON)
	include_directories(${CURL_INCLUDE_DIR})
else()
	message(STATUS "libcurl not found, server downloads won't be available")
	set(ID_ENABLE_CURL OFF)
	set(CURL_LIBRARY "")
endif()

# compiler specific flags
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
	add_definitions(-pipe)
	add_definitions(-Wall)

	if(NOT CMAKE_CROSSCOMPILING AND ONATIVE)
		add_definitions(-march=native)
	elseif(NOT APPLE AND cpu STREQUAL "x86")
		add_definitions(-march=pentium3)
	endif()

	set(CMAKE_C_FLAGS_DEBUG "-g -D_DEBUG -O1")
	set(CMAKE_C_FLAGS_DEBUGALL "-g -ggdb -D_DEBUG")
	set(CMAKE_C_FLAGS_PROFILE "-g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
	set(CMAKE_C_FLAGS_RELEASE "-O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
	set(CMAKE_C_FLAGS_RELWITHDEBINFO "-g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
	set(CMAKE_C_FLAGS_MINSIZEREL "-Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")

	set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
	set(CMAKE_CXX_FLAGS_PROFILE ${CMAKE_C_FLAGS_PROFILE})

	add_definitions(-fno-strict-aliasing)

	CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" cxx_has_fvisibility)
	if(NOT cxx_has_fvisibility)
		message(FATAL_ERROR "Compiler does not support -fvisibility")
	endif()
	add_definitions(-fvisibility=hidden)

	# TODO fix these warnings
	add_definitions(-Wno-sign-compare)
	add_definitions(-Wno-switch)
	add_definitions(-Wno-format-security)

	CHECK_CXX_COMPILER_FLAG("-Woverloaded-virtual" cxx_has_Woverload_virtual)
	if(cxx_has_Woverload_virtual)
		add_definitions(-Woverloaded-virtual)
	endif()

	if(APPLE)
		add_definitions(-DMACOS_X=1)

		if(cpu STREQUAL "x86_64")
			add_definitions(-arch x86_64 -mmacosx-version-min=10.6)
			set(ldflags "${ldflags} -arch x86_64 -mmacosx-version-min=10.6")
		elseif(cpu STREQUAL "x86")
			CHECK_CXX_COMPILER_FLAG("-arch i386" cxx_has_arch_i386)
			if(cxx_has_arch_i386)
				add_definitions(-arch i386)
				set(ldflags "${ldflags} -arch i386")
			endif()

			add_definitions(-mmacosx-version-min=10.4)
			set(ldflags "${ldflags} -mmacosx-version-min=10.4")
		elseif(cpu STREQUAL "ppc")
			CHECK_CXX_COMPILER_FLAG("-arch ppc" cxx_has_arch_ppc)
			if(cxx_has_arch_ppc)
				add_definitions(-arch ppc)
				set(ldflags "${ldflags} -arch ppc")
			endif()

			add_definitions(-mmacosx-version-min=10.4)
			set(ldflags "${ldflags} -mmacosx-version-min=10.4")
		else()
			message(FATAL_ERROR "Unsupported CPU architecture for OSX")
		endif()

		set(sys_libs ${sys_libs} "-framework Carbon -framework Cocoa -framework IOKit")
	elseif(WIN32)
		set(ldflags "${ldflags} -static-libgcc -static-libstdc++")
	else()
		if(os STREQUAL "linux")
			set(sys_libs ${sys_libs} dl)
		endif()
	endif()
elseif(MSVC)
	add_definitions(/W4)
	add_definitions(/wd4100) # unreferenced formal parameter
	add_definitions(/wd4127) # conditional expression is constant
	add_definitions(/wd4244) # possible loss of data
	add_definitions(/wd4245) # signed/unsigned mismatch
	add_definitions(/wd4267) # possible loss of data
	add_definitions(/wd4714) # 'function' marked as __forceinline not inlined
	add_definitions(/wd4996) # 'function': was declared deprecated
	add_definitions(/wd4068) # unknown pragma
	add_definitions(-D_ALLOW_KEYWORD_MACROS) # because of the "#define private public" and "#define protected public" in TypeInfo.cpp
	set(CMAKE_C_FLAGS_DEBUG "-D_DEBUG /Od /Zi /MDd")
	set(CMAKE_C_FLAGS_RELEASE "/Ox /Oy /MD")
	set(CMAKE_C_FLAGS_RELWITHDEBINFO "/Ox /Oy /Zi /MD")
	set(CMAKE_C_FLAGS_MINSIZEREL "/Ox /Oy /Os /MD")
else()
	message(FATAL_ERROR "Unsupported compiler")
endif()

set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
set(CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_C_FLAGS_RELWITHDEBINFO})
set(CMAKE_CXX_FLAGS_MINSIZEREL ${CMAKE_C_FLAGS_MINSIZEREL})

# mingw and msvc
if(WIN32)
	add_definitions(-DWINVER=0x0501)
	add_definitions(-D_WIN32_WINNT=0x0501)

	set(sys_libs ${sys_libs}
		winmm
		iphlpapi
		wsock32
	)
endif()

# fallback for cmake versions without GNUInstallDirs
if(GNUINSTALLDIRS MATCHES "NOTFOUND")
	set(CMAKE_INSTALL_BINDIR		"bin"
		CACHE PATH "user executables (bin)")
	set(CMAKE_INSTALL_LIBDIR		"lib${LIB_SUFFIX}"
		CACHE PATH "object code libraries (lib${LIB_SUFFIX})")
	set(CMAKE_INSTALL_DATAROOTDIR	"share"
		CACHE PATH "read-only architecture-independent data root (share)")
	set(CMAKE_INSTALL_DATADIR		"${CMAKE_INSTALL_DATAROOTDIR}"
		CACHE PATH "read-only architecture-independent data (DATAROOTDIR)")

	mark_as_advanced(CMAKE_INSTALL_BINDIR CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_DATAROOTDIR CMAKE_INSTALL_DATADIR)
	foreach(dir BINDIR LIBDIR DATAROOTDIR DATADIR)
		if(NOT IS_ABSOLUTE ${CMAKE_INSTALL_${dir}})
			set(CMAKE_INSTALL_FULL_${dir} "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_${dir}}")
		else()
			set(CMAKE_INSTALL_FULL_${dir} "${CMAKE_INSTALL_${dir}}")
		endif()
	endforeach()
endif()

set(bindir		"${CMAKE_INSTALL_FULL_BINDIR}")
set(libdir		"${CMAKE_INSTALL_FULL_LIBDIR}/dhewm3")
set(datadir		"${CMAKE_INSTALL_FULL_DATADIR}/dhewm3")

configure_file(
	"${CMAKE_SOURCE_DIR}/config.h.in"
	"${CMAKE_BINARY_DIR}/config.h"
)

message(STATUS "Building ${CMAKE_BUILD_TYPE} for ${os}-${cpu}")

if(NOT APPLE AND NOT WIN32)
	message(STATUS "The install target will use the following directories:")
	message(STATUS "  Binary directory:  ${bindir}")
	message(STATUS "  Library directory: ${libdir}")
	message(STATUS "  Data directory:    ${datadir}")
endif()

set(src_renderer
	renderer/jpeg_memory_src.cpp
	renderer/Cinematic.cpp
	renderer/GuiModel.cpp
	renderer/Image_files.cpp
	renderer/Image_init.cpp
	renderer/Image_load.cpp
	renderer/Image_process.cpp
	renderer/Image_program.cpp
	renderer/Interaction.cpp
	renderer/Material.cpp
	renderer/MegaTexture.cpp
	renderer/Model.cpp
	renderer/ModelDecal.cpp
	renderer/ModelManager.cpp
	renderer/ModelOverlay.cpp
	renderer/Model_beam.cpp
	renderer/Model_ase.cpp
	renderer/Model_liquid.cpp
	renderer/Model_lwo.cpp
	renderer/Model_ma.cpp
	renderer/Model_md3.cpp
	renderer/Model_md5.cpp
	renderer/Model_prt.cpp
	renderer/Model_sprite.cpp
	renderer/RenderEntity.cpp
	renderer/RenderSystem.cpp
	renderer/RenderSystem_init.cpp
	renderer/RenderWorld.cpp
	renderer/RenderWorld_demo.cpp
	renderer/RenderWorld_load.cpp
	renderer/RenderWorld_portals.cpp
	renderer/VertexCache.cpp
	renderer/draw_arb2.cpp
	renderer/draw_common.cpp
	renderer/tr_backend.cpp
	renderer/tr_deform.cpp
	renderer/tr_font.cpp
	renderer/tr_guisurf.cpp
	renderer/tr_light.cpp
	renderer/tr_lightrun.cpp
	renderer/tr_main.cpp
	renderer/tr_orderIndexes.cpp
	renderer/tr_polytope.cpp
	renderer/tr_render.cpp
	renderer/tr_rendertools.cpp
	renderer/tr_shadowbounds.cpp
	renderer/tr_stencilshadow.cpp
	renderer/tr_subview.cpp
	renderer/tr_trace.cpp
	renderer/tr_trisurf.cpp
	renderer/tr_turboshadow.cpp
)

set(src_framework
	framework/CVarSystem.cpp
	framework/CmdSystem.cpp
	framework/Common.cpp
	framework/Compressor.cpp
	framework/Console.cpp
	framework/DemoFile.cpp
	framework/DeclAF.cpp
	framework/DeclEntityDef.cpp
	framework/DeclFX.cpp
	framework/DeclManager.cpp
	framework/DeclParticle.cpp
	framework/DeclPDA.cpp
	framework/DeclSkin.cpp
	framework/DeclTable.cpp
	framework/EditField.cpp
	framework/EventLoop.cpp
	framework/File.cpp
	framework/FileSystem.cpp
	framework/KeyInput.cpp
	framework/UsercmdGen.cpp
	framework/Session_menu.cpp
	framework/Session.cpp
	framework/async/AsyncClient.cpp
	framework/async/AsyncNetwork.cpp
	framework/async/AsyncServer.cpp
	framework/async/MsgChannel.cpp
	framework/async/NetworkSystem.cpp
	framework/async/ServerScan.cpp
	framework/minizip/ioapi.c
	framework/minizip/unzip.cpp
)

set(src_cm
	cm/CollisionModel_contacts.cpp
	cm/CollisionModel_contents.cpp
	cm/CollisionModel_debug.cpp
	cm/CollisionModel_files.cpp
	cm/CollisionModel_load.cpp
	cm/CollisionModel_rotate.cpp
	cm/CollisionModel_trace.cpp
	cm/CollisionModel_translate.cpp
)

set(src_dmap
	tools/compilers/dmap/dmap.cpp
	tools/compilers/dmap/facebsp.cpp
	tools/compilers/dmap/gldraw.cpp
	tools/compilers/dmap/glfile.cpp
	tools/compilers/dmap/leakfile.cpp
	tools/compilers/dmap/map.cpp
	tools/compilers/dmap/optimize.cpp
	tools/compilers/dmap/output.cpp
	tools/compilers/dmap/portals.cpp
	tools/compilers/dmap/shadowopt3.cpp
	tools/compilers/dmap/tritjunction.cpp
	tools/compilers/dmap/tritools.cpp
	tools/compilers/dmap/ubrush.cpp
	tools/compilers/dmap/usurface.cpp
)

set(src_aas
	tools/compilers/aas/AASBuild.cpp
	tools/compilers/aas/AASBuild_file.cpp
	tools/compilers/aas/AASBuild_gravity.cpp
	tools/compilers/aas/AASBuild_ledge.cpp
	tools/compilers/aas/AASBuild_merge.cpp
	tools/compilers/aas/AASCluster.cpp
	tools/compilers/aas/AASFile.cpp
	tools/compilers/aas/AASFile_optimize.cpp
	tools/compilers/aas/AASFile_sample.cpp
	tools/compilers/aas/AASReach.cpp
	tools/compilers/aas/AASFileManager.cpp
	tools/compilers/aas/Brush.cpp
	tools/compilers/aas/BrushBSP.cpp
)

set(src_roq
	tools/compilers/roqvq/NSBitmapImageRep.cpp
	tools/compilers/roqvq/codec.cpp
	tools/compilers/roqvq/roq.cpp
	tools/compilers/roqvq/roqParam.cpp
)

set(src_renderbump

=== debian/changelog ===
dhewm3 (0+git20150226+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #777373)

 -- Tobias Frost <tobi@debian.org>  Tue, 04 Aug 2015 22:51:30 +0200

=== debian/control ===
Source: dhewm3
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Frost <tobi@debian.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libcurl4-gnutls-dev,
               libjpeg-dev,
               libogg-dev,
               libopenal-dev,
               libsdl2-dev,
               libvorbis-dev
Standards-Version: 3.9.6
Homepage: https://github.com/dhewm/dhewm3
VCS-Browser: https://alioth.debian.org/anonscm/git/pkg-games/dhewm3.git
VCS-Git: git://anonscm.debian.org/pkg-games/dhewm3.git

Package: dhewm3-doom3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: dhewm3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: doom3-data | game-data-packager (>=40)
Description: dhwm3's gamelibrary for the title DOOM³
 This package contains the shared library containing the game logic for DOOM³
 .
 Please note that this package does not contain any game data, which is
 required to actually play the game.
 .
 The package game-data-packager can help you to package your copy of the
 game data. Please see Readme.Debian for details.

Package: dhewm3-d3xp
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: dhewm3-doom3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: doom3-resurrection-data | game-data-packager (>=40)
Description: dhwm3's gamelibrary for the title DOOM³: Resurrection of Evil
 This package contains the shared library containing the game logic for
 the add-on DOOM3³: Resurrection of Evil
 .
 Please note that this package does not contain any game data, which is
 required to actually play the game.
 .
 The package game-data-packager can help you to package your copy of the
 game data. Please see README.Debian for details.

Package: dhewm3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dhewm3-doom3, dhewm3-dx3p
Description: GPL Doom 3 game engine
 The goal of dhewm 3 is bring the DOOM3 engine with the help of SDL to all
 suitable plaforms.
 .
 This game engine is compatible with the original Doom3 data files and the
 Resurrection of Evil extension. To play it, you need to own the game data.
 .
 Bugs present in the original DOOM 3 will be fixed (when identified) without
 altering the original gameplay.

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/dhewm3-$1\.tar\.gz/,\
dversionmangle=s/\+git.*$//;s/\+dfsg.*$//,uversionmangle=s/-/~/,\
repacksuffix=+dfsg \
  https://github.com/dhewm/dhewm3/tags .*/v?(\d\S*)\.tar\.gz

## dhewm3 1.4.0+dfsg

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
+cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
 project(dhewm3)
-cmake_minimum_required(VERSION 2.6)
 
 # TODO
 
@@ -17,11 +17,20 @@
 # LIBC_MALLOC		-DUSE_LIBC_MALLOC=0
 # ID_NOLANADDRESS	-DID_NOLANADDRESS
 
+# fallback for cmake versions without add_compile_options
+if(NOT COMMAND add_compile_options)
+	function(add_compile_options)
+		foreach(arg ${ARGN})
+			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${arg}" PARENT_SCOPE)
+			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${arg}" PARENT_SCOPE)
+		endforeach()
+	endfunction()
+endif()
+
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/sys/cmake")
 set(CMAKE_SKIP_RPATH ON CACHE BOOL "Skip RPATH" FORCE)
 
 include(CheckCXXCompilerFlag)
-include(CheckFunctionExists)
 include(GNUInstallDirs OPTIONAL RESULT_VARIABLE GNUINSTALLDIRS)
 
 option(CORE			"Build the core" ON)
@@ -29,7 +38,7 @@
 option(D3XP			"Build the d3xp game code" ON)
 option(DEDICATED	"Build the dedicated server" OFF)
 option(ONATIVE		"Optimize for the host CPU" OFF)
-option(SDL2			"Use SDL2 instead of SDL1.2" OFF)
+option(SDL2			"Use SDL2 instead of SDL1.2" ON)
 
 if(NOT CMAKE_SYSTEM_PROCESSOR)
 	message(FATAL_ERROR "No target CPU architecture set")
@@ -86,7 +95,6 @@
 
 set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
 set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARY})
-CHECK_FUNCTION_EXISTS("jpeg_mem_src" HAVE_JPEG_MEM_SRC)
 
 find_package(OGG REQUIRED)
 include_directories(${OGG_INCLUDE_DIR})
@@ -130,13 +138,13 @@
 
 # compiler specific flags
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
-	add_definitions(-pipe)
-	add_definitions(-Wall)
+	add_compile_options(-pipe)
+	add_compile_options(-Wall)
 
 	if(NOT CMAKE_CROSSCOMPILING AND ONATIVE)
-		add_definitions(-march=native)
+		add_compile_options(-march=native)
 	elseif(NOT APPLE AND cpu STREQUAL "x86")
-		add_definitions(-march=pentium3)
+		add_compile_options(-march=pentium3)
 	endif()
 
 	set(CMAKE_C_FLAGS_DEBUG "-g -D_DEBUG -O1")
@@ -149,47 +157,47 @@
 	set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
 	set(CMAKE_CXX_FLAGS_PROFILE ${CMAKE_C_FLAGS_PROFILE})
 
-	add_definitions(-fno-strict-aliasing)
+	add_compile_options(-fno-strict-aliasing)
 
 	CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" cxx_has_fvisibility)
 	if(NOT cxx_has_fvisibility)
 		message(FATAL_ERROR "Compiler does not support -fvisibility")
 	endif()
-	add_definitions(-fvisibility=hidden)
+	add_compile_options(-fvisibility=hidden)
 
 	# TODO fix these warnings
-	add_definitions(-Wno-sign-compare)
-	add_definitions(-Wno-switch)
-	add_definitions(-Wno-format-security)
+	add_compile_options(-Wno-sign-compare)
+	add_compile_options(-Wno-switch)
+	add_compile_options(-Wno-format-security)
 
 	CHECK_CXX_COMPILER_FLAG("-Woverloaded-virtual" cxx_has_Woverload_virtual)
 	if(cxx_has_Woverload_virtual)
-		add_definitions(-Woverloaded-virtual)
+		add_compile_options(-Woverloaded-virtual)
 	endif()
 
 	if(APPLE)
 		add_definitions(-DMACOS_X=1)
 
 		if(cpu STREQUAL "x86_64")
-			add_definitions(-arch x86_64 -mmacosx-version-min=10.6)
+			add_compile_options(-arch x86_64 -mmacosx-version-min=10.6)
 			set(ldflags "${ldflags} -arch x86_64 -mmacosx-version-min=10.6")
 		elseif(cpu STREQUAL "x86")
 			CHECK_CXX_COMPILER_FLAG("-arch i386" cxx_has_arch_i386)
 			if(cxx_has_arch_i386)
-				add_definitions(-arch i386)
+				add_compile_options(-arch i386)
 				set(ldflags "${ldflags} -arch i386")
 			endif()
 
-			add_definitions(-mmacosx-version-min=10.4)
+			add_compile_options(-mmacosx-version-min=10.4)
 			set(ldflags "${ldflags} -mmacosx-version-min=10.4")
 		elseif(cpu STREQUAL "ppc")
 			CHECK_CXX_COMPILER_FLAG("-arch ppc" cxx_has_arch_ppc)
 			if(cxx_has_arch_ppc)
-				add_definitions(-arch ppc)
+				add_compile_options(-arch ppc)
 				set(ldflags "${ldflags} -arch ppc")
 			endif()
 
-			add_definitions(-mmacosx-version-min=10.4)
+			add_compile_options(-mmacosx-version-min=10.4)
 			set(ldflags "${ldflags} -mmacosx-version-min=10.4")
 		else()
 			message(FATAL_ERROR "Unsupported CPU architecture for OSX")
@@ -198,21 +206,19 @@
 		set(sys_libs ${sys_libs} "-framework Carbon -framework Cocoa -framework IOKit")
 	elseif(WIN32)
 		set(ldflags "${ldflags} -static-libgcc -static-libstdc++")
-	else()
-		if(os STREQUAL "linux")
-			set(sys_libs ${sys_libs} dl)
-		endif()
+	elseif(os STREQUAL "linux")
+		set(sys_libs ${sys_libs} dl)
 	endif()
 elseif(MSVC)
-	add_definitions(/W4)
-	add_definitions(/wd4100) # unreferenced formal parameter
-	add_definitions(/wd4127) # conditional expression is constant
-	add_definitions(/wd4244) # possible loss of data
-	add_definitions(/wd4245) # signed/unsigned mismatch
-	add_definitions(/wd4267) # possible loss of data
-	add_definitions(/wd4714) # 'function' marked as __forceinline not inlined
-	add_definitions(/wd4996) # 'function': was declared deprecated
-	add_definitions(/wd4068) # unknown pragma
+	add_compile_options(/W4)
+	add_compile_options(/wd4100) # unreferenced formal parameter
+	add_compile_options(/wd4127) # conditional expression is constant
+	add_compile_options(/wd4244) # possible loss of data
+	add_compile_options(/wd4245) # signed/unsigned mismatch
+	add_compile_options(/wd4267) # possible loss of data
+	add_compile_options(/wd4714) # 'function' marked as __forceinline not inlined
+	add_compile_options(/wd4996) # 'function': was declared deprecated
+	add_compile_options(/wd4068) # unknown pragma
 	add_definitions(-D_ALLOW_KEYWORD_MACROS) # because of the "#define private public" and "#define protected public" in TypeInfo.cpp
 	set(CMAKE_C_FLAGS_DEBUG "-D_DEBUG /Od /Zi /MDd")
 	set(CMAKE_C_FLAGS_RELEASE "/Ox /Oy /MD")
@@ -236,6 +242,7 @@
 		winmm
 		iphlpapi
 		wsock32
+		ole32
 	)
 endif()
 
@@ -279,7 +286,6 @@
 endif()
 
 set(src_renderer
-	renderer/jpeg_memory_src.cpp
 	renderer/Cinematic.cpp
 	renderer/GuiModel.cpp
 	renderer/Image_files.cpp
@@ -404,16 +410,3 @@
 	tools/compilers/aas/AASFile_optimize.cpp
 	tools/compilers/aas/AASFile_sample.cpp
 	tools/compilers/aas/AASReach.cpp
-	tools/compilers/aas/AASFileManager.cpp
-	tools/compilers/aas/Brush.cpp
-	tools/compilers/aas/BrushBSP.cpp
-)
-
-set(src_roq
-	tools/compilers/roqvq/NSBitmapImageRep.cpp
-	tools/compilers/roqvq/codec.cpp
-	tools/compilers/roqvq/roq.cpp
-	tools/compilers/roqvq/roqParam.cpp
-)
-
-set(src_renderbump

=== debian/changelog ===
dhewm3 (1.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release. (Closes: #802676)
    - Refresh patch
  * d/copyright: Remove jpeg_memory_src.* from Files-Excluded, as removed
    upstream.
  * Typo in d/control
  * Update d/watch to also mangle RC versions

 -- Tobias Frost <tobi@debian.org>  Sat, 21 Nov 2015 23:43:04 +0100

dhewm3 (0+git20150724+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot
  * Remove patch 02-remove-jpeg_memory_src.patch -- applied upstream
  * Fix recommends to point to dhewm3-d3xp instead of non-existing package
    dhewm3-dx3p (Closes: #795979)
  * Fix description of d/control: It's README.Debian.
  * Fix typo in d/copyright

 -- Tobias Frost <tobi@debian.org>  Sun, 13 Sep 2015 21:25:15 +0200

=== debian/control ===
--- 
+++ 
@@ -23,14 +23,14 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: doom3-data | game-data-packager (>=40)
-Description: dhwm3's gamelibrary for the title DOOM³
+Description: dhewm3's gamelibrary for the title DOOM³
  This package contains the shared library containing the game logic for DOOM³
  .
  Please note that this package does not contain any game data, which is
  required to actually play the game.
  .
  The package game-data-packager can help you to package your copy of the
- game data. Please see Readme.Debian for details.
+ game data. Please see README.Debian for details.
 
 Package: dhewm3-d3xp
 Architecture: any
@@ -39,7 +39,7 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: doom3-resurrection-data | game-data-packager (>=40)
-Description: dhwm3's gamelibrary for the title DOOM³: Resurrection of Evil
+Description: dhewm3's gamelibrary for the title DOOM³: Resurrection of Evil
  This package contains the shared library containing the game logic for
  the add-on DOOM3³: Resurrection of Evil
  .
@@ -52,7 +52,7 @@
 Package: dhewm3
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Suggests: dhewm3-doom3, dhewm3-dx3p
+Suggests: dhewm3-doom3, dhewm3-d3xp
 Description: GPL Doom 3 game engine
  The goal of dhewm 3 is bring the DOOM3 engine with the help of SDL to all
  suitable plaforms.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
DH_VERBOSE = 1

%:
	dh $@ -Dneo --parallel

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DSDL2=ON \
	-DCMAKE_INSTALL_BINDIR="games" -DCMAKE_INSTALL_DATADIR="share/games" \
	-DCMAKE_BUILD_TYPE=Debian

override_dh_installdocs:
	dh_installdocs -A debian/license-assessment

# For get-orig-source
UURL =  https://github.com/dhewm/dhewm3.git
PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER  ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog  -SVersion | sed -e s/^.*git// -e s/+dfsg// | cut -d- -f1 )
DTYPE = +dfsg
UPSVER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | cut -d+ -f1)

## from: https://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz
	#$(info I: $(UPSVER$)+$(PKG)_$(VER)$(DTYPE))
	@

UDATE = $(shell date --rfc-3339=seconds --date='TZ="UTC" \
	$(shell echo +git$(VER) | perl -ne 'print "$$1-$$2-$$3" if m/\+(?:git|svn|hg)(\d{4})(\d{2})(\d{2})/')')

$(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz:
	@echo DEBUG: VER=$(VER) UDATE=$(UDATE) UPSVER=$(UPSVER)
	@echo "$(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz"
	@echo $(VER) | grep -q '^[0-9]*$$' || ( echo Cannot find timestamp in package version. Please specify VER, see README.source. Aborting.. ; exit 1 )
	#$(info I: UDATE=$(UDATE))
	$(if $(wildcard $(PKG)-$(UPSVER)+git$(VER)),$(error $(PKG)-$(UPSVER)+git$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(UPSVER)+git$(VER) \
	|| $(RM) -r $(PKG)-$(UPSVER)+git$(VER)
	cd $(PKG)-$(UPSVER)+git$(VER) \
	&& git checkout v$(VER) || git checkout $$(git log -n1 --format=%h --before="$(UDATE)") \
	&& ( echo "# Generating ChangeLog..." \
	&& git log --pretty="format:%ad  %aN  <%aE>%n%n%x09* %s%n" --date=short > ChangeLog \
	&& touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	&& echo "# Setting times..." \
	&& for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	&& echo "# Cleaning-up..." \
	&& $(RM) -r -v $$(awk 'BEGIN{RS=ORS="\n\n";FS=OFS="\n"}/Files-Excluded:/' $(PKD)/copyright | sed -n -e '/^Files-Excluded:/,$${p}' | sed s/Files-Excluded://) \
	&& $(RM) -r .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(UPSVER)+git$(VER)" -xdev -type f -print | sort \
	| XZ_OPT="-6v" tar -caf "$(PKG)_$(UPSVER)+git$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	&& $(RM) -r "$(PKG)-$(UPSVER)+git$(VER)"

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/dhewm3-$1\.tar\.gz/,\
dversionmangle=s/\+git.*$//;s/\+dfsg.*$//,uversionmangle=s/-/~/,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
repacksuffix=+dfsg \
  https://github.com/dhewm/dhewm3/tags .*/v?(\d\S*)\.tar\.gz

## dhewm3 1.4.1+dfsg

=== debian/changelog ===
dhewm3 (1.4.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Fix VCS-Browser in d/control.
  * Bump S-V to 3.9.8 -- no changes
  * Correct spelling error in README.Debian

 -- Tobias Frost <tobi@debian.org>  Fri, 08 Jul 2016 01:10:09 +0200

=== debian/control ===
--- 
+++ 
@@ -11,10 +11,10 @@
                libopenal-dev,
                libsdl2-dev,
                libvorbis-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/dhewm/dhewm3
-VCS-Browser: https://alioth.debian.org/anonscm/git/pkg-games/dhewm3.git
-VCS-Git: git://anonscm.debian.org/pkg-games/dhewm3.git
+VCS-Browser: https://anonscm.debian.org/cgit/pkg-games/dhewm3.git
+VCS-Git: https://anonscm.debian.org/git/pkg-games/dhewm3.git
 
 Package: dhewm3-doom3
 Architecture: any

## dhewm3 1.4.1+git20171102+dfsg

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,8 @@
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/sys/cmake")
 set(CMAKE_SKIP_RPATH ON CACHE BOOL "Skip RPATH" FORCE)
 
+set(DHEWM3BINARY "dhewm3")
+
 include(CheckCXXCompilerFlag)
 include(GNUInstallDirs OPTIONAL RESULT_VARIABLE GNUINSTALLDIRS)
 
@@ -107,6 +109,11 @@
 
 find_package(OpenAL REQUIRED)
 include_directories(${OPENAL_INCLUDE_DIR})
+
+if(NOT AROS)
+	find_package(X11 REQUIRED)
+	include_directories(${X11_INCLUDE_DIR})
+endif()
 
 if (SDL2)
 	# skip SDL2main
@@ -159,11 +166,13 @@
 
 	add_compile_options(-fno-strict-aliasing)
 
-	CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" cxx_has_fvisibility)
-	if(NOT cxx_has_fvisibility)
-		message(FATAL_ERROR "Compiler does not support -fvisibility")
-	endif()
-	add_compile_options(-fvisibility=hidden)
+	if(NOT AROS)
+		CHECK_CXX_COMPILER_FLAG("-fvisibility=hidden" cxx_has_fvisibility)
+		if(NOT cxx_has_fvisibility)
+			message(FATAL_ERROR "Compiler does not support -fvisibility")
+		endif()
+		add_compile_options(-fvisibility=hidden)
+	endif()
 
 	# TODO fix these warnings
 	add_compile_options(-Wno-sign-compare)
@@ -175,7 +184,10 @@
 		add_compile_options(-Woverloaded-virtual)
 	endif()
 
-	if(APPLE)
+	if(AROS)
+		set(CMAKE_SHARED_LIBRARY_SUFFIX ".aros-${cpu}")
+		add_definitions(-DIOAPI_NO_64)
+	elseif(APPLE)
 		add_definitions(-DMACOS_X=1)
 
 		if(cpu STREQUAL "x86_64")
@@ -403,10 +415,3 @@
 	tools/compilers/aas/AASBuild.cpp
 	tools/compilers/aas/AASBuild_file.cpp
 	tools/compilers/aas/AASBuild_gravity.cpp
-	tools/compilers/aas/AASBuild_ledge.cpp
-	tools/compilers/aas/AASBuild_merge.cpp
-	tools/compilers/aas/AASCluster.cpp
-	tools/compilers/aas/AASFile.cpp
-	tools/compilers/aas/AASFile_optimize.cpp
-	tools/compilers/aas/AASFile_sample.cpp
-	tools/compilers/aas/AASReach.cpp

=== debian/changelog ===
dhewm3 (1.4.1+git20171102+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot.
  * d/control: Fix spelling error in package description.
  * Update d/compat level to 10, update B-D on debhelper >10 and  drop
    --parallel in d/rules.
  * Update S-V to 4.1.1. Only change was using the https:// for the
    copyright format URL, as this is now allowed.
  * Update d/copyright years
  * Fix spelling error in README.Debian
  * Use /usr/share/dpkg/pkg-info.mk instead of dpkg-parsechangelog
  * Refresh patch 01-changedatadir.patch
  * Adding patch to fix FTBFS on ppc64el. Thanks to Frédéric Bonnard for
    providing it. (Closes: #868156)

 -- Tobias Frost <tobi@debian.org>  Tue, 28 Nov 2017 20:21:13 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Tobias Frost <tobi@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 10),
                libcurl4-gnutls-dev,
                libjpeg-dev,
                libogg-dev,
                libopenal-dev,
                libsdl2-dev,
                libvorbis-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: https://github.com/dhewm/dhewm3
 VCS-Browser: https://anonscm.debian.org/cgit/pkg-games/dhewm3.git
 VCS-Git: https://anonscm.debian.org/git/pkg-games/dhewm3.git
@@ -55,7 +55,7 @@
 Suggests: dhewm3-doom3, dhewm3-d3xp
 Description: GPL Doom 3 game engine
  The goal of dhewm 3 is bring the DOOM3 engine with the help of SDL to all
- suitable plaforms.
+ suitable platforms.
  .
  This game engine is compatible with the original Doom3 data files and the
  Resurrection of Evil extension. To play it, you need to own the game data.

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,12 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/pkg-info.mk
+
 # output every command that modifies files on the build system.
-DH_VERBOSE = 1
+#DH_VERBOSE = 1
 
 %:
-	dh $@ -Dneo --parallel
+	dh $@ -Dneo
 
 # debmake generated override targets
 # This is example for Cmake (See http://bugs.debian.org/641051 )
@@ -20,10 +22,10 @@
 # For get-orig-source
 UURL =  https://github.com/dhewm/dhewm3.git
 PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
-PKG   = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
-VER  ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog  -SVersion | sed -e s/^.*git// -e s/+dfsg// | cut -d- -f1 )
+PKG   = $(DEB_SOURCE)
+VER   ?= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e s/^.*git// -e s/+dfsg// | cut -d- -f1 )
 DTYPE = +dfsg
-UPSVER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog -SVersion | cut -d+ -f1)
+UPSVER  ?= $(shell echo $(DEB_VERSION_UPSTREAM) | cut -d+ -f1)
 
 ## from: https://wiki.debian.org/onlyjob/get-orig-source
 .PHONY: get-orig-source

## dhewm3 1.4.1+git20180714+dfsg

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -157,8 +157,8 @@
 	set(CMAKE_C_FLAGS_DEBUG "-g -D_DEBUG -O1")
 	set(CMAKE_C_FLAGS_DEBUGALL "-g -ggdb -D_DEBUG")
 	set(CMAKE_C_FLAGS_PROFILE "-g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
-	set(CMAKE_C_FLAGS_RELEASE "-O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
-	set(CMAKE_C_FLAGS_RELWITHDEBINFO "-g -O3 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELEASE "-O2 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELWITHDEBINFO "-g -O2 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
 	set(CMAKE_C_FLAGS_MINSIZEREL "-Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
 
 	set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})

=== debian/changelog ===
dhewm3 (1.4.1+git20180714+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Spelling error patch partially applied upstream, refreshing.
  * Bump SV to 4.1.5:
    - Set Rules-Requires-Root to "no"
    - no other changes required.

 -- Tobias Frost <tobi@debian.org>  Thu, 26 Jul 2018 00:15:00 +0800

dhewm3 (1.4.1+git20180223+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Move repository to salsa.d.o.
  * Update watch file to track repository and remove get-orig-source from
    d/rules.
  * Add patch to correct spelling errors.
  * Use compat level 11.
  * Bump S-V to 3.1.4, no changes required.

 -- Tobias Frost <tobi@debian.org>  Sat, 19 May 2018 02:13:27 +0200

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,18 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Tobias Frost <tobi@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 10),
+               debhelper (>= 11),
                libcurl4-gnutls-dev,
                libjpeg-dev,
                libogg-dev,
                libopenal-dev,
                libsdl2-dev,
                libvorbis-dev
-Standards-Version: 4.1.1
+Standards-Version: 4.1.5
 Homepage: https://github.com/dhewm/dhewm3
-VCS-Browser: https://anonscm.debian.org/cgit/pkg-games/dhewm3.git
-VCS-Git: https://anonscm.debian.org/git/pkg-games/dhewm3.git
+VCS-Browser: https://salsa.debian.org/games-team/dhewm3
+VCS-Git: https://salsa.debian.org/games-team/dhewm3.git
+Rules-Requires-Root: no
 
 Package: dhewm3-doom3
 Architecture: any

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=1.4.1+git%cd+dfsg, dversionmangle=s/\+dfsg\d*$//" \
https://github.com/dhewm/dhewm3.git \
HEAD debian uupdate

## dhewm3 1.5.0+git20181221+dfsg

=== neo/CMakeLists.txt ===
--- 
+++ 
@@ -27,8 +27,19 @@
 	endfunction()
 endif()
 
+option(LINUX_RELEASE_BINS "Set RPATH to \$ORIGIN/libs/ for Linux binary releases" OFF)
+
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/sys/cmake")
-set(CMAKE_SKIP_RPATH ON CACHE BOOL "Skip RPATH" FORCE)
+
+if(LINUX_RELEASE_BINS)
+	message(STATUS "Setting RPATH to \$ORIGIN/libs/ so you can put dependencies in there")
+	set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
+	set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
+	set(CMAKE_INSTALL_RPATH "$ORIGIN/libs")
+	set(ldflags "${ldflags} -Wl,-z,origin") # not sure this is even needed, but shouldn't hurt
+else()
+	set(CMAKE_SKIP_RPATH ON CACHE BOOL "Skip RPATH" FORCE)
+endif()
 
 set(DHEWM3BINARY "dhewm3")
 
@@ -154,12 +165,12 @@
 		add_compile_options(-march=pentium3)
 	endif()
 
-	set(CMAKE_C_FLAGS_DEBUG "-g -D_DEBUG -O1")
+	set(CMAKE_C_FLAGS_DEBUG "-g -ggdb -D_DEBUG -O0")
 	set(CMAKE_C_FLAGS_DEBUGALL "-g -ggdb -D_DEBUG")
 	set(CMAKE_C_FLAGS_PROFILE "-g -ggdb -D_DEBUG -O1 -fno-omit-frame-pointer")
-	set(CMAKE_C_FLAGS_RELEASE "-O2 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
-	set(CMAKE_C_FLAGS_RELWITHDEBINFO "-g -O2 -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
-	set(CMAKE_C_FLAGS_MINSIZEREL "-Os -ffast-math -fno-unsafe-math-optimizations -fomit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELEASE "-O2 -fno-unsafe-math-optimizations -fno-math-errno -fno-trapping-math -fomit-frame-pointer")
+	set(CMAKE_C_FLAGS_RELWITHDEBINFO "-g -ggdb -O2 -fno-unsafe-math-optimizations -fno-math-errno -fno-trapping-math -fno-omit-frame-pointer")
+	set(CMAKE_C_FLAGS_MINSIZEREL "-Os -fno-unsafe-math-optimizations -fno-math-errno -fno-trapping-math -fomit-frame-pointer")
 
 	set(CMAKE_CXX_FLAGS_DEBUGALL ${CMAKE_C_FLAGS_DEBUGALL})
 	set(CMAKE_CXX_FLAGS_PROFILE ${CMAKE_C_FLAGS_PROFILE})
@@ -231,6 +242,7 @@
 	add_compile_options(/wd4714) # 'function' marked as __forceinline not inlined
 	add_compile_options(/wd4996) # 'function': was declared deprecated
 	add_compile_options(/wd4068) # unknown pragma
+	add_compile_options(/wd4458) # declaration of 'variable' hides class member
 	add_definitions(-D_ALLOW_KEYWORD_MACROS) # because of the "#define private public" and "#define protected public" in TypeInfo.cpp
 	set(CMAKE_C_FLAGS_DEBUG "-D_DEBUG /Od /Zi /MDd")
 	set(CMAKE_C_FLAGS_RELEASE "/Ox /Oy /MD")
@@ -241,9 +253,10 @@
 endif()
 
 set(CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
-set(CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
 set(CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_C_FLAGS_RELWITHDEBINFO})
-set(CMAKE_CXX_FLAGS_MINSIZEREL ${CMAKE_C_FLAGS_MINSIZEREL})
+# disable assertions in release builds
+set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG ${CMAKE_C_FLAGS_RELEASE}")
+set(CMAKE_CXX_FLAGS_MINSIZEREL "-DNDEBUG ${CMAKE_C_FLAGS_MINSIZEREL}")
 
 # mingw and msvc
 if(WIN32)
@@ -394,24 +407,3 @@
 	cm/CollisionModel_translate.cpp
 )
 
-set(src_dmap
-	tools/compilers/dmap/dmap.cpp
-	tools/compilers/dmap/facebsp.cpp
-	tools/compilers/dmap/gldraw.cpp
-	tools/compilers/dmap/glfile.cpp
-	tools/compilers/dmap/leakfile.cpp
-	tools/compilers/dmap/map.cpp
-	tools/compilers/dmap/optimize.cpp
-	tools/compilers/dmap/output.cpp
-	tools/compilers/dmap/portals.cpp
-	tools/compilers/dmap/shadowopt3.cpp
-	tools/compilers/dmap/tritjunction.cpp
-	tools/compilers/dmap/tritools.cpp
-	tools/compilers/dmap/ubrush.cpp
-	tools/compilers/dmap/usurface.cpp
-)
-
-set(src_aas
-	tools/compilers/aas/AASBuild.cpp
-	tools/compilers/aas/AASBuild_file.cpp
-	tools/compilers/aas/AASBuild_gravity.cpp

=== debian/changelog ===
dhewm3 (1.5.0+git20181221+dfsg-2) unstable; urgency=medium

  * Refresh patch.
  * Used SDL2.cmake to avoid FTBFS. See #951087 for details.
  * Fix lintian warning in debian/copyright
  * Bump S-V to 4.5.0 -- no changes
  * Use debhelper-compat instead of d/compat. Bump to level 12.

 -- Tobias Frost <tobi@debian.org>  Tue, 07 Apr 2020 17:36:51 +0200

dhewm3 (1.5.0+git20181221+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot. (Upstream marked this as version 1.5.0)
    - remove patch with spelling errors -- applied upstream.
  * Bump SV to 4.3.0 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Sat, 29 Dec 2018 17:16:34 +0100

dhewm3 (1.4.2~pre+git20180930+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot.
    - Adapt d/watch for upstrem version 1.4.2~pre.
    - Project has a new homepage
    - Update d/copyright.
  * Revise patch 20-spelling-errors.patch after upstream feeback.
  * Bump S-V to 4.2.1 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Sat, 20 Oct 2018 10:12:31 +0200

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,15 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Tobias Frost <tobi@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 11),
+               debhelper-compat (= 12),
                libcurl4-gnutls-dev,
                libjpeg-dev,
                libogg-dev,
                libopenal-dev,
-               libsdl2-dev,
+               libsdl2-dev (>= 2.0.4),
                libvorbis-dev
-Standards-Version: 4.1.5
-Homepage: https://github.com/dhewm/dhewm3
+Standards-Version: 4.5.0
+Homepage: https://dhewm3.org/
 VCS-Browser: https://salsa.debian.org/games-team/dhewm3
 VCS-Git: https://salsa.debian.org/games-team/dhewm3.git
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# output every command that modifies files on the build system.
#DH_VERBOSE = 1

%:
	dh $@ -Dneo

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DSDL2=ON \
	-DCMAKE_INSTALL_BINDIR="games" -DCMAKE_INSTALL_DATADIR="share/games" \
	-DCMAKE_BUILD_TYPE=Debian

override_dh_installdocs:
	dh_installdocs -A debian/license-assessment

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=1.5.0+git%cd+dfsg, dversionmangle=s/\+dfsg\d*$//" \
https://github.com/dhewm/dhewm3.git \
HEAD debian uupdate

## dhewm3 1.5.1~pre+git20200802+dfsg

=== debian/changelog ===
dhewm3 (1.5.1~pre+git20200802+dfsg-1) unstable; urgency=medium

  * New upstream git snapshot.
    - refresh patches.
    - d/rules: Enable upstreams reproducible build option.
  * Make Vcs field cute and lintian happy.

 -- Tobias Frost <tobi@debian.org>  Tue, 25 Aug 2020 16:50:12 +0200

dhewm3 (1.5.1~pre+git20200130+dfsg-1) unstable; urgency=medium

  * New upstream git snaphot, versioned upstream as 1.5.1pre.
    - Update watch file to match new version.
    - Remove 10-ppc64el-build.patch -- applied upstream.
    - Refresh remaining patches.

 -- Tobias Frost <tobi@debian.org>  Mon, 13 Apr 2020 09:53:59 +0200

=== debian/control ===
--- 
+++ 
@@ -13,8 +13,8 @@
                libvorbis-dev
 Standards-Version: 4.5.0
 Homepage: https://dhewm3.org/
-VCS-Browser: https://salsa.debian.org/games-team/dhewm3
-VCS-Git: https://salsa.debian.org/games-team/dhewm3.git
+Vcs-Browser: https://salsa.debian.org/games-team/dhewm3
+Vcs-Git: https://salsa.debian.org/games-team/dhewm3.git
 Rules-Requires-Root: no
 
 Package: dhewm3-doom3
